#
# securityDefines = [
# {'perm':permname,'methods':['func1',....],'roles':[role1,...]},
# ...
#]
#
from AccessControl import ClassSecurityInfo
from AccessControl.Role import RoleManager
#from AccessControl.SecurityManagement import SecurityManagement
import Globals

def setupClassSecurity(security,securityDefines) :
    """
    """
    for i in securityDefines :
        if i['perm']=='_Public' :
            funcs = i['methods']
            if type(funcs)!=type([]) :
                funcs = [funcs]
            for j in funcs :
                if j == 'self' :
                    security.declareObjectPublic()
                else :
                    security.declarePublic(j)
        elif i['perm']=='_Private' :
            funcs = i['methods']
            if type(funcs)!=type([]) :
                funcs = [funcs]
            for j in funcs :
                if j == 'self' :
                    security.declareObjectPrivate()
                else :
                    security.declarePrivate(j)
        else :
            funcs = i['methods']
            if type(funcs)!=type([]) :
                funcs = [funcs]
            for j in funcs :
                if j == 'self' :
                    security.declareObjectProtected(i['perm'])
                else :
                    security.declareProtected(i['perm'],j)
            security.setPermissionDefault(i['perm'],i['roles'])

def initClassSecurity(klass) :
	"""
	"""
	if not hasattr(klass,'security') :
		setattr(klass,'security',ClassSecurityInfo())
	secu = getattr(klass,'security',None)
	sdef = getattr(klass,'securityDefines',None)
	if secu and sdef:
              setupClassSecurity(secu,sdef)
	setattr(klass,'security',secu)
